.\" @(#)linesize.3t	1.2 5/2/90
.\"
.\" Copyright (c) 1990 by Sam Leffler.
.\" All rights reserved.
.\"
.\" This file is provided for unrestricted use provided that this
.\" legend is included on all tape media and as a part of the
.\" software program in whole or part.  Users may copy, modify or
.\" distribute this file at will.
.\"
.TH TIFFScanlineSize 3T "May 2, 1990"
.SH NAME
TIFFScanlineSize \- return the size (in bytes) of a scanline for an open
.SM TIFF
file
.SH SYNOPSIS
.B "#include <tiffio.h>"
.br
.B "int TIFFScanlineSize(TIFF* tif)"
.SH DESCRIPTION
Return the size (in bytes) of a row of data as it would be
returned in a call to
.IR TIFFReadScanline (),
or as it would be expected in a call to
.IR TIFFWriteScanline ().
This size is typically used when dynamically allocating
I/O buffers.
.SH DIAGNOSTICS
None.
.SH "SEE ALSO"
.IR intro (3T),
.IR TIFFOpen (3T),
.IR TIFFReadScanline (3T),
.IR TIFFWriteScanline (3T)
